PosixFileAttributes (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.nio.file.attribute, interface: PosixFileAttributes
Keywords: java.nio.file.attribute.PosixFileAttributes interface

# Interface PosixFileAttributes

All Superinterfaces:
  `BasicFileAttributes`

public interface PosixFileAttributes extends BasicFileAttributes
File attributes associated with files on file systems used by operating systems that implement the Portable Operating System Interface (POSIX) family of standards.

The POSIX attributes of a file are retrieved using a `PosixFileAttributeView` by invoking its `readAttributes` method.

Since:
  1.7

- ## Method Summary

  Modifier and Type
  Method
  Description
  `GroupPrincipal`
  `group()`
  Returns the group owner of the file.
  `UserPrincipal`
  `owner()`
  Returns the owner of the file.
  `Set<PosixFilePermission>`
  `permissions()`
  Returns the permissions of the file.

  ### Methods declared in interface BasicFileAttributes

  `creationTime, fileKey, isDirectory, isOther, isRegularFile, isSymbolicLink, lastAccessTime, lastModifiedTime, size`
  Modifier and Type
  Method
  Description
  `FileTime`
  `creationTime()`
  Returns the creation time.
  `Object`
  `fileKey()`
  Returns an object that uniquely identifies the given file, or `null` if a file key is not available.
  `boolean`
  `isDirectory()`
  Tells whether the file is a directory.
  `boolean`
  `isOther()`
  Tells whether the file is something other than a regular file, directory, or symbolic link.
  `boolean`
  `isRegularFile()`
  Tells whether the file is a regular file with opaque content.
  `boolean`
  `isSymbolicLink()`
  Tells whether the file is a symbolic link.
  `FileTime`
  `lastAccessTime()`
  Returns the time of last access.
  `FileTime`
  `lastModifiedTime()`
  Returns the time of last modification.
  `long`
  `size()`
  Returns the size of the file (in bytes).

- ## Method Details

  - ### owner

    UserPrincipal owner()
    Returns the owner of the file.
    Returns:
      the file owner
    See Also:
      - `FileOwnerAttributeView.setOwner(UserPrincipal)`

  - ### group

    GroupPrincipal group()
    Returns the group owner of the file.
    Returns:
      the file group owner
    See Also:
      - `PosixFileAttributeView.setGroup(GroupPrincipal)`

  - ### permissions

    Set<PosixFilePermission> permissions()
    Returns the permissions of the file. The file permissions are returned as a set of `PosixFilePermission` elements. The returned set is a copy of the file permissions and is modifiable. This allows the result to be modified and passed to the `setPermissions` method to update the file's permissions.
    Returns:
      the file permissions
    See Also:
      - `PosixFileAttributeView.setPermissions(Set)`